
import 'package:bitcoin_flutter/bitcoin_flutter.dart' as btcCore;
import 'coins_btc.dart';

class CoinsBch extends CoinsBtc{
  @override
  String get coinType => "BCH";
  @override
  int get decimals => 8;
   // String get derivePath => "m/44'/145'/0'/0/0";
  @override
  String  derivePath(String subPath){
    return "m/44'/145'/$subPath";
  }
  @override
  Object get network => _bitcoincash;
  static final _bitcoincash = btcCore.NetworkType(
      messagePrefix: '\x18Bitcoin Signed Message:\n',
      bech32: 'bc',
      bip32: new btcCore.Bip32Type(
          public: 0x0488b21e, private: 0x0488ade4),
      pubKeyHash: 0x00,
      scriptHash: 0x05,
      wif: 0x80);

  @override
  String get coinInfo => "比特币现金（BCH）";
  @override
  String get imagePath => "coin/BCH";
}