// import 'dart:typed_data';
//
// import 'package:filecoinwallet/filecoinplugin.dart';
//
// import '../coins_base.dart';
// import 'package:web3dart/credentials.dart';
// import 'package:web3dart/crypto.dart';
// import 'package:web3dart/web3dart.dart';
// import 'package:blake2/blake2.dart' as filBlake2;
// import 'package:base32/base32.dart' as base32Encode;
// import '../rlp.dart';
//
// import 'dart:convert';
// class UnsignedMessageAPI {
//   String to;
//   String from;
//   int nonce;
//   String value;
//   int gas_limit;
//   String gasFeeCap;
//   String gasPremium;
//   int method;
//   String params = "";
//
//
//   Map toJson() {
//     Map map = new Map();
//     map["to"] = this.to;
//     map["from"] = this.from;
//     map["nonce"] = this.nonce;
//     map["value"] = this.value;
//     map["gas_limit"] = this.gas_limit;
//     map["gasFeeCap"] = this.gasFeeCap;
//     map["gasPremium"] = this.gasPremium;
//     map["method"] = this.method;
//     map["params"] = this.params;
//
//     return map;
//   }
// }
//
//
// class CoinsFil extends CoinsBase{
//
//   @override
//   String get coinType => "FIL";
//
//   @override
//   int get decimals => 8;
//
//   int get gasLimit=>21000;
//   @override
//   String get coinInfo => "IPFS上的一个代币（Filecoin）";
//
//   @override
//   String get imagePath => "coin/ETH";
//
//   @override
//   bool get isHaveToken => true;
//
//   @override
//   bool get isOpen => true;
//
//   //根据公钥属性，属于测试网（t），还是正式网（f）
//   //是钱包地址（1）  是合约地址（2） 加上相应的前缀
//   @override
//   Future<String> getAddress(String subPath) async {
//     //步骤
//     //1. 助记词 生成私钥
//     //2. 私钥 得到 公钥  【私钥，可以直接得到非压缩的65字节的公钥。私钥->压缩公钥33B->解压缩公钥65B】
//     //3. 公钥 加 04 前辍 得到 X
//     //4. Blake2b 20长度 ,用 X 得到 Y
//     //5. Y 加 01 前辍
//     //6. Blake2b 4长度 用 Y 得到 Z
//     //7. Y 和 Z 相连，base32。得到Fil 地址。
//
//     //print("--------------------");
//     String pK = await getPrivateKey(subPath);
//     //print("--------------------"+pK);
//
//     //print("--------------------22");
//     var mAddr = await Filecoinplugin.getprkAddress(pK);
//     //print("--------------------"+s);
//     //print(subPath+"-pK");
//     //print(pK);
//
//     return mAddr;
//   }
//
//
//
//
//   @override
//   Future<String> transactionMain(String subPath,String fromAddress, String toAddress,
//       num amount, num gasPrice, Map otherPrams) async {
//
//
//     //我这面用的是官方的莲花节点
//     //1. 创建交易  通过交易参数构建序列化结构体
//     //2. 签名
//
//
//     int nonce  = otherPrams["nonce"];
//     UnsignedMessageAPI mUnSign=new UnsignedMessageAPI();
//     mUnSign.nonce=nonce;
//     mUnSign.to=toAddress;
//     mUnSign.from=fromAddress;
//
//     mUnSign.value=amount.toString();
//     mUnSign.gas_limit= gasPrice;
//     mUnSign.gasFeeCap=otherPrams["gasFeeCap"];
//     mUnSign.gasPremium=otherPrams["gasPremium"];
//     mUnSign.method=0;
//     mUnSign.params = "";
//
//     String pK = await getPrivateKey(subPath);
//
//     print("===以下是输入参数===");
//     print("pK="+pK);
//     print("mUnSign.toString()="+jsonEncode(mUnSign));
//
//     print("===进入Fil 插件啦 ！===");
//     String txPack = await Filecoinplugin.getSign(jsonEncode(mUnSign),pK);
//     print("插件结果res=="+txPack);
//     return txPack;
//
//   }
//
//   @override
//   Future<String> transactionToken(String subPath,String fromAddress, String toAddress,
//       num amount, num gasPrice,String contractAddress, Map otherPrams) async {
//
//   }
//   @override
//   String  derivePath(String subPath){
//     return "m/44'/461'/$subPath";
//   }
//
//   @override
//   Object get network => 1;
//
//
//
// }